/*
    pwl9x "Windows 9x PassWord List reader"
    Copyright (C) 2001 Knispel Guillaume

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>

#include "defs.h"
#include "crk.h"

static bool stop;
static dword *flag5A;

void mark(int sig)
{
  stop = 1;
  *flag5A=0x55AA55AA;
}

int crk_start(int (*crk_core)(paramspace *workspace), paramspace *workspace,
		size_t szwkspc, Params *p, Pwl *pwl, dword *flagK)
{
  int i, k, n; FILE *alpha; bool first; char tmpinc[256];

  printf("Crack\n---\n\n");

  if (!p->have_alphabet) { fprintf(stderr, "The only method implemented right now is brute forcing, please provide an alphabet.\n"); exit(EMET); }

  for (i = 0; i < 256; i++) tmpinc[i]  = 0;
  if (!(alpha = fopen(p->abc_file, "ro"))) { fprintf(stderr, "Bad alphabet file name.\n"); exit(EMET); }
  while ((i = fgetc(alpha))!=EOF) {
    if (i != '\n') tmpinc[i] = 1;
  }
  fclose(alpha);

  if (p->have_pwd) {
    for(i=0; p->pwd[i]; i++) if (!tmpinc[(byte)p->pwd[i]]) { fprintf(stderr, "Initial password seed contains invalid char '%c'.\n", p->pwd[i]); exit(EPWD); }
    n = strlen(p->pwd);
  } else n = 0;

  if (n > p->maxpwdlen) { fprintf(stderr, "Warning : start password longer than max password lenght, assume it's the correct one.\n"); return -1; }

  flag5A = flagK; signal(SIGINT, mark); signal(SIGTERM, mark);

  first = true;
  do {
    printf("Trying passwords of lenght %d\n", n);
    memset(workspace, 0, szwkspc);
    strcpy(workspace->name, p->username); workspace->salt = pwl->head->salt[0x10];
    memcpy(workspace->sign, pwl->head->sign, sizeof(hres) * 2);
    for(k = i = 0; i < 256; i++) if (tmpinc[i]) { workspace->incr[k] = i; k = i; }; workspace->incr[k] = workspace->incr[0];
    if (first) { first = false; if (p->have_pwd) strcpy(workspace->pwd, p->pwd); } 
    else { for (i = 0; i < n; i++) workspace->pwd[i] = workspace->incr[0]; }
    workspace->pwd[n] = 0;
    n++;
  } while(!(p->have_pwd = crk_core(workspace)) && !stop && (n <= p->maxpwdlen));

  if (stop) p->interrupted = true;

  return n;
}
