/*
    pwl9x "Windows 9x PassWord List reader"
    Copyright (C) 2001 Knispel Guillaume

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef   list_h
#define   list_h


#include "defs.h"

typedef struct {        /* main cryptotable, produced after hashing */
  byte body[256];                              /* data table itself */
  byte c1,c2;                    /* crypto pointers into data table */
} xor_table;

typedef struct {                   /* main hash container structure */
 hblk buf;                               /* buffer for hashing data */
 dword cnt[4];                            /* internal hash counters */
 dword idx[2];                    /* internal data position pointer */
} hash_container;

void try_list(Params *p, Pwl *pwl);


#endif /* list_h */
