/*
    pwl9x "Windows 9x PassWord List reader"
    Copyright (C) 2001 Knispel Guillaume

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>

#include "defs.h"
#include "mmx.h"
#include "crk.h"

void try_crack_pwl_mmx(Params *p, Pwl *pwl)
{
  int i, j, k, m, n; mmxworkspace *buff8al;
  char buff[sizeof(mmxworkspace)+8], what[8] = {0, 2, 4, 6, 7, 5, 3, 1};
  
  buff8al = (mmxworkspace *)((((unsigned int)buff) + 7) & ~7);
  n = crk_start((int (*)(paramspace *))mmxcrk, (paramspace *)buff8al,
		sizeof(mmxworkspace), p, pwl, (dword *)((void*)buff8al+8));
  if (n==-1) return;

  if (p->have_pwd || p->interrupted) {
    if (!(p->pwd = malloc(n--))) { fprintf(stderr, "Could not allocate enough memory.\n"); exit(EMEM); }

    if (p->have_pwd) { for (i = k = 0; i < 8; i++) if (((char *)buff8al)[i]) { k = what[i]; break; }
                       m = 4 - (k>>1); k &= 1; k <<= 2; } else k = m = 0;
    for (j = 0, i = k; (p->pwd[j] = buff8al->mmxspc[i+256]); ++j, i = ((j&~3)<<1) + (j&3) + k);
    if (p->have_pwd) {
      if (n) while (m--) {
        char *linc = buff8al->mmxspc+2944; int r; k = 0;
        do {
	  r = p->pwd[k];
	  for (i = 1; (i < 256) && (p->pwd[k] != linc[i]); i++); p->pwd[k] = i;
	  k++; linc = buff8al->incr;
        } while (i >= r && k < n);
      }
    }

    printf(p->have_pwd?"The main password seems to be \"%s\"\n\n":
                       "The next password to check is \"%s\"\n\n", p->pwd);
  } else printf("The main password has not been found\n");
}
