/*
    pwl9x "Windows 9x PassWord List reader"
    Copyright (C) 2001 Knispel Guillaume

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef mmx_h
#define mmx_h


#include "defs.h"

typedef struct {
  dword salt;     /* check salt */
  dword alq;      /* align quad */
  hres sign;      /* Signature, rc4 crypted, and to be hashed */
  hres check;     /* Check value of last hash (rc4 crypted) */
  char name[40];
  char pwd[40];
  char incr[256];
  /* end of params space */
  char mmxspc[3200];
} mmxworkspace;

int mmxcrk(mmxworkspace *workspace);
void try_crack_pwl_mmx(Params *p, Pwl *pwl);


#endif /* mmx_h */
