/*
    pwl9x "Windows 9x PassWord List reader"
    Copyright (C) 2001 Knispel Guillaume

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

.text

/*	Byte to quadword desinterlace */
	.align 16
b2qd:
	pushl	%edi

	movl	8(%esp), %eax
	movl	12(%esp), %edi

	movq	(%eax), %mm0		/* ACEGHFDB0 */
	movq	%mm0, %mm4
	movq	8(%eax), %mm1		/* ACEGHFDB1 */
	punpcklbw %mm1, %mm0		/* ACEG01 */
	movq	16(%eax), %mm2		/* ACEGHFDB2 */
	movq	%mm2, %mm6
	movq	24(%eax), %mm3		/* ACEGHFDB3 */
	
	punpckhbw %mm1, %mm4		/* HFDB01 */
	movq	%mm0, %mm1
	punpcklbw %mm3, %mm2		/* ACEG23 */
	movq	%mm4, %mm5
	punpckhbw %mm3, %mm6		/* HFDB23 */
	movq	56(%eax), %mm3
	punpcklwd %mm2, %mm0		/* AC0123 */
	punpckhwd %mm2, %mm1		/* EG0123 */
	movq	48(%eax), %mm2
	movq	%mm0, (%edi)
	punpcklwd %mm6, %mm4		/* HF0123 */
	movq	%mm1, 32(%edi)
	punpckhwd %mm6, %mm5		/* DB0123 */
	movq	32(%eax), %mm0
	movq	%mm4, 64(%edi)
	movq	40(%eax), %mm1
	movq	%mm5, 96(%edi)

	movq	%mm0, %mm4
	punpcklbw %mm1, %mm0
	movq	%mm2, %mm6
	punpckhbw %mm1, %mm4
	movq	%mm0, %mm1
	punpcklbw %mm3, %mm2
	movq	%mm4, %mm5
	punpckhbw %mm3, %mm6
	movq	88(%eax), %mm3
	punpcklwd %mm2, %mm0
	punpckhwd %mm2, %mm1
	movq	80(%eax), %mm2
	movq	%mm0, 8(%edi)
	punpcklwd %mm6, %mm4
	movq	%mm1, 40(%edi)
	punpckhwd %mm6, %mm5
	movq	64(%eax), %mm0
	movq	%mm4, 72(%edi)
	movq	72(%eax), %mm1
	movq	%mm5, 104(%edi)

	movq	%mm0, %mm4
	punpcklbw %mm1, %mm0
	movq	%mm2, %mm6
	punpckhbw %mm1, %mm4
	movq	%mm0, %mm1
	punpcklbw %mm3, %mm2
	movq	%mm4, %mm5
	punpckhbw %mm3, %mm6
	movq	120(%eax), %mm3
	punpcklwd %mm2, %mm0
	punpckhwd %mm2, %mm1
	movq	112(%eax), %mm2
	movq	%mm0, 16(%edi)
	punpcklwd %mm6, %mm4
	movq	%mm1, 48(%edi)
	punpckhwd %mm6, %mm5
	movq	96(%eax), %mm0
	movq	%mm4, 80(%edi)
	movq	104(%eax), %mm1
	movq	%mm5, 112(%edi)

	movq	%mm0, %mm4
	punpcklbw %mm1, %mm0
	movq	%mm2, %mm6
	punpckhbw %mm1, %mm4
	movq	%mm0, %mm1
	punpcklbw %mm3, %mm2
	movq	%mm4, %mm5
	punpckhbw %mm3, %mm6
	punpcklwd %mm2, %mm0
	punpcklwd %mm6, %mm4
	movq	%mm0, 24(%edi)
	punpckhwd %mm2, %mm1
	movq	%mm4, 88(%edi)
	punpckhwd %mm6, %mm5
	movq	%mm1, 56(%edi)
	movq	%mm5, 120(%edi)

	popl	%edi
	ret


/*	Quadword to byte interlace	*/
	.align 16
q2bi:
	pushl	%edi

	movl	8(%esp), %eax
	movl	12(%esp), %edi

	movq	(%eax), %mm0	/* AB0123 */
	movq	32(%eax), %mm1  /* CD0123 */
	punpcklbw %mm1, %mm0	/* AC0..AC3 */
	movq	64(%eax), %mm2	/* EF0123 */
	movq	%mm0, %mm4	/* AC0..AC3 */
	movq	96(%eax), %mm3	/* GH0123 */
	punpckhbw (%eax), %mm1  /* DB0..DB3 */
	punpcklbw %mm3, %mm2	/* EG0..EG3 */
	punpckhbw 64(%eax), %mm3 /*HF0..HF3 */
	movq	%mm3, %mm7	/* HF0..HF3 */
	punpcklwd %mm2, %mm0	/* ACEG0ACEG1 */
	punpckhwd %mm2, %mm4	/* ACEG2ACEG3 */
	movq	%mm4, %mm5	/* ACEG2ACEG3 */
	punpcklwd %mm1, %mm3	/* HFDB0HFDB1 */
	punpckhwd %mm1, %mm7	/* HFDB2HFDB3 */
	movq	%mm0, %mm1	/* ACEG0ACEG1 */
	punpckldq %mm3, %mm0	/* ACEGHFDB0 */
	movq	72(%eax), %mm2
	punpckhdq %mm3, %mm1	/* ACEGHFDB1 */
	movq	%mm0, (%edi)
	movq	104(%eax), %mm3
	punpckldq %mm7, %mm4	/* ACEGHFDB2 */
	movq	%mm1, 8(%edi)
	punpckhdq %mm7, %mm5	/* ACEGHFDB3 */
	movq	%mm4, 16(%edi)
	movq	8(%eax), %mm0
	movq	%mm5, 24(%edi)
	movq	40(%eax), %mm1
	
	punpcklbw %mm3, %mm2
	punpcklbw %mm1, %mm0
	punpckhbw 72(%eax), %mm3
	movq	%mm0, %mm4
	punpckhbw 8(%eax), %mm1
	movq	%mm3, %mm7
	punpcklwd %mm2, %mm0
	punpckhwd %mm2, %mm4
	movq	%mm4, %mm5
	punpcklwd %mm1, %mm3
	punpckhwd %mm1, %mm7
	movq	%mm0, %mm1
	punpckldq %mm3, %mm0
	movq	80(%eax), %mm2
	punpckhdq %mm3, %mm1
	movq	%mm0, 32(%edi)
	movq	112(%eax), %mm3
	punpckldq %mm7, %mm4
	movq	%mm1, 40(%edi)
	punpckhdq %mm7, %mm5
	movq	%mm4, 48(%edi)
	movq	16(%eax), %mm0
	movq	%mm5, 56(%edi)
	movq	48(%eax), %mm1
	
	punpcklbw %mm3, %mm2
	punpcklbw %mm1, %mm0
	punpckhbw 80(%eax), %mm3
	movq	%mm0, %mm4
	punpckhbw 16(%eax), %mm1
	movq	%mm3, %mm7
	punpcklwd %mm2, %mm0
	punpckhwd %mm2, %mm4
	movq	%mm4, %mm5
	punpcklwd %mm1, %mm3
	punpckhwd %mm1, %mm7
	movq	%mm0, %mm1
	punpckldq %mm3, %mm0
	movq	88(%eax), %mm2
	punpckhdq %mm3, %mm1
	movq	%mm0, 64(%edi)
	movq	120(%eax), %mm3
	punpckldq %mm7, %mm4
	movq	%mm1, 72(%edi)
	punpckhdq %mm7, %mm5
	movq	%mm4, 80(%edi)
	movq	24(%eax), %mm0
	movq	%mm5, 88(%edi)
	movq	56(%eax), %mm1
	
	punpcklbw %mm3, %mm2
	punpcklbw %mm1, %mm0
	punpckhbw 88(%eax), %mm3
	movq	%mm0, %mm4
	punpckhbw 24(%eax), %mm1
	movq	%mm3, %mm7
	punpcklwd %mm2, %mm0
	punpckhwd %mm2, %mm4
	movq	%mm4, %mm5
	punpcklwd %mm1, %mm3
	punpckhwd %mm1, %mm7
	movq	%mm0, %mm1
	punpckldq %mm3, %mm0
	punpckhdq %mm3, %mm1
	movq	%mm0, 96(%edi)
	punpckldq %mm7, %mm4
	movq	%mm1, 104(%edi)
	punpckhdq %mm7, %mm5
	movq	%mm4, 112(%edi)
	movq	%mm5, 120(%edi)

	popl	%edi
	ret

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Main brute force pwl breaking sub			       *
 * Input :	& of its workspace (including paramspace)      *
 *		assume the mmx-specific workspace (that is     *
 *              everything but paramspace) is 0 filled	       *
 * Output :	1 = password found, extract the current from   *
 *		    k0, and use (char[8])(buff8al) flags to    *
 *		    get it back				       *
 *		0 = password not found, try one char longer    *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
	
#define salt	0
#define sign	8
#define check	24
#define name	40
#define pwd	80
#define incr	120
#define fkeep	376
#define k0	632
#define v1	760
#define k1	888
#define v2	2936
#define k2	3064
#define k3	3192
#define incr2   3320
#define endbuf  3576

	.align 16
incrby2:
	pushl	%ebx

	xorl	%eax, %eax
	leal	incr2(%esi), %ebp
pwdp2loop1:
	cmpl	%eax, %edx
	movl	%eax, %ecx
	jna	detect_eos
	movl	%eax, %edi
	andl	$~3, %ecx
	andl	$3, %edi
	shll	%ecx
	orl	%edi, %ecx
	incl	%eax
	movzbl	k0(%esi, %ecx), %edi
	movzbl	(%edi, %ebp), %ebx
	cmpl	%edi, %ebx
	movb	%bl, k0(%esi, %ecx)
	leal	incr(%esi), %ebp
	jbe	pwdp2loop1
	jmp	outpwdp2_1
detect_eos:
	movl	$0x55AA55AA, sign(%esi)
outpwdp2_1:
	xorl	%eax, %eax
	leal	incr2(%esi), %ebp
pwdp2loop2:
	cmpl	%eax, %edx
	movl	%eax, %ecx
	jna	outpwdp2_2
	movl	%eax, %edi
	andl	$~3, %ecx
	andl	$3, %edi
	shll	%ecx
	orl	$4, %edi
	orl	%edi, %ecx
	incl	%eax
	movzbl	k0(%esi, %ecx), %edi
	movzbl	(%edi, %ebp), %ebx
	cmpl	%edi, %ebx
	movb	%bl, k0(%esi, %ecx)
	leal	incr(%esi), %ebp
	jbe	pwdp2loop2
outpwdp2_2:

	popl	%ebx
	ret

	.align 16
prek3:
	pushl	%edx
	
	movl	%edx, %edi
	movl	%edx, %eax
	andl	$~3, %edi
	leal	k3(%esi, %edi, 2), %edi
	andl	$3, %eax
	jz	z3r0_2

	movq	(%ebx), %mm0
	shll	$3, %eax
	pcmpeqd	%mm4, %mm4
	movq	8(%ebx), %mm1
	movl	$32, %edx
	movd	%eax, %mm6
	movq	(%edi), %mm7
	subl	%eax, %edx
	movq	%mm0, %mm2
	movd	%edx, %mm5
	pslld	%mm6, %mm0
	movq	%mm1, %mm3
	pslld	%mm6, %mm1
	psrld	%mm5, %mm4
	pand	%mm4, %mm7
	psrld	%mm5, %mm2
	por	%mm7, %mm0
	psrld	%mm5, %mm3
	por	%mm2, %mm1
	movl	$0x80, %eax
	movq	%mm0, (%edi)
	movq	16(%ebx), %mm0
	movq	%mm1, 8(%edi)
	movq	24(%ebx), %mm1
	movq	%mm0, %mm2
	pslld	%mm6, %mm0
	por	%mm3, %mm0
	psrld	%mm5, %mm2
	movd	%eax, %mm4
	movq	%mm0, 16(%edi)
	movq	%mm1, %mm3
	pslld	%mm6, %mm1
	por	%mm2, %mm1
	psrld	%mm5, %mm3
	punpckldq %mm4, %mm4
	movq	%mm1, 24(%edi)
	pslld	%mm6, %mm4
	por	%mm4, %mm3
	movq	%mm3, 32(%edi)
	jmp	hf_cont
z3r0_2:
	movq	(%ebx), %mm0
	movl	$0x80, %eax
	movq	8(%ebx), %mm1
	movd	%eax, %mm4
	movq	16(%ebx), %mm2
	punpckldq %mm4, %mm4
	movq	24(%ebx), %mm3
	movq	%mm0, (%edi)
	movq	%mm1, 8(%edi)
	movq	%mm2, 16(%edi)
	movq	%mm3, 24(%edi)
	movq	%mm4, 32(%edi)
hf_cont:

	popl	%edx
	ret
	
	.align 16
	.globl mmxcrk
mmxcrk:
	pushl	%ebx
	pushl	%ecx
	pushl	%edx
	pushl	%esi
	pushl	%edi
	pushl	%ebp /* don't remove, used by incrby2 */
	
	movl	28(%esp), %esi

	movq	sign(%esi), %mm0	/*abcdefgh*/
	xorl	%ecx, %ecx
	
	/* signcheck --> fkeep */
	/* we need to do that cause later there will be an 8x RC4 decode pass */
xpd_signcheck:	
	movq	%mm0, %mm1
	punpcklbw %mm0, %mm0		/*aabbccdd*/
	movq	%mm0, %mm2		
	punpckhbw %mm1, %mm1		/*eeffgghh*/
	movq	%mm1, %mm3
	punpcklwd %mm0, %mm0		/*aaaabbbb*/
	movq	%mm0, %mm4
	punpcklwd %mm1, %mm1		/*eeeeffff*/
	movq	%mm1, %mm5
	punpckhwd %mm2, %mm2		/*ccccdddd*/
	movq	%mm2, %mm6
	punpckhwd %mm3, %mm3		/*gggghhhh*/
	movq	%mm3, %mm7
	punpckldq %mm0, %mm0		/*aaaaaaaa*/
	punpckhdq %mm4, %mm4		/*bbbbbbbb*/
	movq	%mm0, fkeep+0*8(%esi, %ecx, 8)
	punpckldq %mm1, %mm1		/*eeeeeeee*/
	movq	%mm4, fkeep+1*8(%esi, %ecx, 8)
	movq	sign+8(%esi, %ecx), %mm0
	punpckhdq %mm5, %mm5		/*ffffffff*/
	movq	%mm1, fkeep+4*8(%esi, %ecx, 8)
	punpckldq %mm2, %mm2		/*cccccccc*/
	movq	%mm5, fkeep+5*8(%esi, %ecx, 8)
	punpckhdq %mm6, %mm6		/*dddddddd*/
	movq	%mm2, fkeep+2*8(%esi, %ecx, 8)
	punpckldq %mm3, %mm3		/*gggggggg*/
	movq	%mm6, fkeep+3*8(%esi, %ecx, 8)
	punpckhdq %mm7, %mm7		/*hhhhhhhh*/
	addl	$8, %ecx
	movq	%mm3, fkeep+6*8-64(%esi, %ecx, 8)
	cmp	$32, %ecx
	movq	%mm7, fkeep+7*8-64(%esi, %ecx, 8)
	jnz	xpd_signcheck

	/* Compute the first H & prepare K3	*/
	/* First H is made from :	d[-1]bs[NAMEZ]d[SALT] b[80]bs[0...0]d[sz]d[0] */
	/* Where the last part comes from MD5 & sz is the lenght of the first part << 3 */
	/* K3 will later be :	 bs[NAMEZ][Hfac] ... */
	/* So to compute H we use a part of K3 & a part of K2 (indeed its last 8 bytes) */
	/* K2 will be overwriten later */
	pcmpeqd	%mm0, %mm0
	xorl	%eax, %eax		/* strlen + 1 */
	leal	name(%esi), %edi
	movl	$40, %ecx
	repne
	scasb
	subl	$40, %ecx
	neg	%ecx
	pushl	%ecx
	
	xorl	%ebx, %ebx
	movq	%mm0, k3-8(%esi)
xpd_namez:
	movd	name(%esi, %ebx), %mm1
	addl	$4, %ebx
	punpckldq %mm1, %mm1
	cmpl	%ebx, %ecx
	movq	%mm1, k3-8(%esi, %ebx, 2)
	ja	xpd_namez

	movd	salt(%esi), %mm0
	movl	%ecx, %eax
	andl	$3, %eax
	punpckldq %mm0, %mm0
	jz	z3r0_0

	shll	$3, %eax
	pcmpeqd	%mm5, %mm5	/* FF FF FF FF FF FF FF FF */
	movl	$0x80, %edx
	movl	$32, %edi
	movd	%edx, %mm7	/* 00 00 00 00 00 00 00 80 */
	subl	%eax, %edi
	punpckldq %mm7, %mm7	/* 00 00 00 80 00 00 00 80 */
	movd	%eax, %mm2	/* 00 00 00 00 00 00 00 sl */
	movq	%mm0, %mm4	/* s3 s2 s1 s0 s3 s2 s1 s0 */
	movd	%edi, %mm3	/* 00 00 00 00 00 00 00 sr */
	pslld	%mm2, %mm7	/* 80 00 00 00 80 00 00 00  4 xempl */
	psrld	%mm3, %mm5	/* 00 FF FF FF 00 FF FF FF  4 xempl */
	pand	%mm5, %mm1	/* 00 00 NM NM 00 00 NM NM  4 xempl */
	psrld	%mm3, %mm4	/* 00 s3 s2 s1 00 s3 s2 s1  4 xempl */
	por	%mm7, %mm4	/* 80 s3 s2 s1 80 s3 s2 s1  4 xempl */
	pslld	%mm2, %mm0	/* s0 00 00 00 s0 00 00 00  4 xempl */
	por	%mm1, %mm0	/* s0 00 NM NM s0 00 NM NM  4 xempl */
	movq	%mm4, k3(%esi, %ebx, 2)
	movq	%mm0, k3-8(%esi, %ebx, 2)
	jmp	h0cont
z3r0_0:
	movq	%mm0, k3(%esi, %ebx, 2)
	movl	$0x80, %eax
	movd	%eax, %mm0
	punpckldq %mm0, %mm0
	movq	%mm0, k3+8(%esi, %ebx, 2)
h0cont:
	addl	$8, %ecx
	shll	$3, %ecx
	movd	%ecx, %mm0
	punpckldq %mm0, %mm0
	movq	%mm0, k3+104(%esi)
	leal	v1(%esi), %ebx
	pushl	%ebx
	leal	k3-8(%esi), %eax
	pushl	%eax
	call	mmx_h_md5
	addl	$8, %esp

	/* Prepare KO */
	xorl	%eax, %eax		/* strlen + 1 */
	leal	pwd(%esi), %edi
	movl	$40, %ecx
	repne
	scasb
	subl	$40, %ecx
	neg	%ecx

	xorl	%ebx, %ebx
xpd_pwdz:
	movd	pwd(%esi, %ebx), %mm7
	addl	$4, %ebx
	punpckldq %mm7, %mm7
	cmpl	%ebx, %ecx
	movq	%mm7, k0-8(%esi, %ebx, 2)
	ja	xpd_pwdz

	movl	%ecx, %eax
	andl	$3, %eax
	jz	z3r0_1

	movq	v1(%esi), %mm0
	shll	$3, %eax
	pcmpeqd	%mm4, %mm4
	movq	v1+8(%esi), %mm1
	movl	$32, %edx
	movd	%eax, %mm6
	subl	%eax, %edx
	movd	%edx, %mm5
	movq	%mm0, %mm2
	pslld	%mm6, %mm0
	movq	%mm1, %mm3
	pslld	%mm6, %mm1
	psrld	%mm5, %mm4
	psrld	%mm5, %mm2
	psrld	%mm5, %mm3
	pand	%mm4, %mm7
	por	%mm7, %mm0
	por	%mm2, %mm1
	movq	%mm0, k0-8(%esi, %ebx, 2)
	movq	%mm1, k0(%esi, %ebx, 2)
	movq	v1+16(%esi), %mm0
	movq	%mm0, %mm2
	pslld	%mm6, %mm0
	psrld	%mm5, %mm2
	por	%mm3, %mm0
	movq	%mm0, k0+8(%esi, %ebx, 2)
	movq	v1+24(%esi), %mm1
	movq	%mm1, %mm3
	pslld	%mm6, %mm1
	psrld	%mm5, %mm3
	por	%mm2, %mm1
	movq	%mm1, k0+16(%esi, %ebx, 2)
	movl	$0x80, %eax
	movd	%eax, %mm4
	punpckldq %mm4, %mm4
	pslld	%mm6, %mm4
	por	%mm4, %mm3
	movq	%mm3, k0+24(%esi, %ebx, 2)
	jmp	preh1_cont
z3r0_1:
	movq	v1(%esi), %mm0
	movl	$0x80, %eax
	movq	v1+8(%esi), %mm1
	movd	%eax, %mm4
	movq	v1+16(%esi), %mm2
	punpckldq %mm4, %mm4
	movq	v1+24(%esi), %mm3
	movq	%mm0, k0(%esi, %ebx, 2)
	movq	%mm1, k0+8(%esi, %ebx, 2)
	movq	%mm2, k0+16(%esi, %ebx, 2)
	movq	%mm3, k0+24(%esi, %ebx, 2)
	movq	%mm4, k0+32(%esi, %ebx, 2)
preh1_cont:
	movl	%ecx, %edx
	addl	$16, %ecx
	shll	$3, %ecx
	movd	%ecx, %mm0
	punpckldq %mm0, %mm0
	movq	%mm0, k0+112(%esi)

	/* Prepare K3 */
	movq	k3+104(%esi), %mm2
	movl	$64, %eax
	pxor	%mm0, %mm0
	movd	%eax, %mm1
	punpckldq %mm1, %mm1
	movq	%mm0, k3+104(%esi)
	paddd	%mm1, %mm2
	movq	%mm2, k3+112(%esi)

	/* Prepare incr2 */
	movzbl	incr(%esi), %eax
	movzbl	incr(%esi, %eax), %edi
incr2loop:
	movzbl	incr(%esi, %eax), %ebx
	movzbl	incr(%esi, %ebx), %ecx
	cmpl	%ecx, %edi
	movb	%cl, incr2(%esi, %eax)
	movl	%ebx, %eax
	jnz	incr2loop

	/* Prepare K0 (incr 2nd pwd) */
	xorl	%eax, %eax
	decl	%edx
pwdpploop:
	cmpl	%eax, %edx
	movl	%eax, %ecx
	jna	outpwdpp
	movl	%eax, %edi
	andl	$~3, %ecx
	andl	$3, %edi
	shll	%ecx
	orl	$4, %edi
	orl	%edi, %ecx
	incl	%eax
	movzbl	k0(%esi, %ecx), %edi
	movzbl	incr(%esi, %edi), %ebx
	cmpl	%edi, %ebx
	movb	%bl, k0(%esi, %ecx)
	jbe	pwdpploop
outpwdpp:
	pxor	%mm0, %mm0
	movq	%mm0, sign(%esi)
	movq	%mm0, (%esi)

/*********************************/
	/* MAIN LOOP */
/*********************************/
	.p2align 4
mainloop:
	cmpl	$0x55AA55AA, sign(%esi)
	je	part_mmxcrk

	leal	v1(%esi), %ebx
	leal	k0(%esi), %ecx
	pushl	%ebx
	addl	$32, %ebx
	pushl	%ecx
	call	mmx_h_md5
	call	incrby2
	movl	%ebx, 4(%esp)
	addl	$32, %ebx
	call	mmx_h_md5
	call	incrby2
	movl	%ebx, 4(%esp)
	addl	$32, %ebx
	call	mmx_h_md5
	call	incrby2
	movl	%ebx, 4(%esp)
	subl	$32*3, %ebx
	call	mmx_h_md5
	call	incrby2
	addl	$8, %esp

	leal	v2(%esi), %ecx
	pushl	%ecx
	pushl	%ebx
	call	q2bi
	addl	$8, %esp

	leal	k1(%esi), %ebx
	pushl	%ebx
	pushl	%ecx
	call	mmx_mkxor
	addl	$8, %esp

	movq	8(%ebx), %mm7
	movl	$1, %eax
	pushl	$17
	leal	v2(%esi), %ecx
	pushl	%ecx
	leal	fkeep(%esi), %edi
	pushl	%edi
	pushl	%ebx
	call	mmx_rcxor
	movq	%mm7, k3-8(%esi)
	addl	$16, %esp

	leal	v1(%esi), %ebx
	pushl	%ebx
	pushl	%ecx
	call	b2qd
	addl	$8, %esp

	movl	%edx, %edi
	popl	%edx
	pushl	%edi
	
	leal	k3(%esi), %ecx
	pushl	%ebx
	pushl	%ecx
	call	prek3
	addl	$32, %ebx
	call	mmx_h_md5
	movl	%ebx, 4(%esp)
	call	prek3
	addl	$32, %ebx
	call	mmx_h_md5
	movl	%ebx, 4(%esp)
	call	prek3
	addl	$32, %ebx
	call	mmx_h_md5
	movl	%ebx, 4(%esp)
	call	prek3
	subl	$32*3, %ebx
	call	mmx_h_md5
	addl	$8, %esp

	movl	%edx, %edi
	popl	%edx
	pushl	%edi

	movq	(%ebx), %mm0
	movq	32(%ebx), %mm1
	movq	64(%ebx), %mm2
	movq	96(%ebx), %mm3
	movq	%mm0, %mm4	/* CA3210 */
	punpckhdq %mm0, %mm0	/* CC3210 */
	movq	%mm1, %mm5	/* GE3210 */
	punpckhdq %mm1, %mm1	/* GG3210 */
	movq	%mm2, %mm6	/* FH3210 */
	punpckhdq %mm2, %mm2	/* FF3210 */
	movq	%mm3, %mm7	/* BD3210 */
	punpckhdq %mm3, %mm3	/* BB3210 */
	punpcklbw %mm0, %mm4	/* CA3CA2CA1CA0 */
	movq	k2(%esi), %mm0
	punpcklbw %mm1, %mm5	/* GE3GE2GE1GE0 */
	punpcklbw %mm2, %mm6	/* FH3FH2FH1FH0 */
	punpcklbw %mm3, %mm7	/* BD3BD2BD1BD0 */
	punpcklwd %mm5, %mm4	/* GECA1GECA0 */
	punpcklwd %mm7, %mm6	/* BDFH1BDFH0 */
	punpckldq %mm6, %mm4	/* BDFHGECA0 */
	pcmpeqb	%mm0, %mm4
	movq	%mm4, k3-16(%esi)

	movd	%mm4, %eax
	punpckhdq %mm4, %mm4
	testl	%eax, %eax
	movd	%mm4, %ebx
	jnz	specycle
	testl	%ebx, %ebx
	jnz	specycle

	jmp	mainloop

	.p2align 4
specycle:
	movl	$18, %eax
	movq	k3-8(%esi), %mm7
	pushl	$18
	leal	v2(%esi), %ecx
	pushl	%ecx
	leal	fkeep(%esi), %edi
	pushl	%edi
	leal	k1(%esi), %ebx
	pushl	%ebx
	call	mmx_rcxor
	movq	%mm7, k3-8(%esi)
	addl	$16, %esp
	
	leal	v1(%esi), %ebx
	movq	(%ebx), %mm0
	movq	32(%ebx), %mm1
	movq	64(%ebx), %mm2
	movq	96(%ebx), %mm3
	movq	%mm0, %mm4	/* CA3210 */
	punpckhdq %mm0, %mm0	/* CC3210 */
	movq	%mm1, %mm5	/* GE3210 */
	punpckhdq %mm1, %mm1	/* GG3210 */
	movq	%mm2, %mm6	/* FH3210 */
	punpckhdq %mm2, %mm2	/* FF3210 */
	movq	%mm3, %mm7	/* BD3210 */
	punpckhdq %mm3, %mm3	/* BB3210 */
	punpcklbw %mm0, %mm4	/* CA3CA2CA1CA0 */
	movq	k2+8(%esi), %mm0
	punpcklbw %mm1, %mm5	/* GE3GE2GE1GE0 */
	punpcklbw %mm2, %mm6	/* FH3FH2FH1FH0 */
	punpcklbw %mm3, %mm7	/* BD3BD2BD1BD0 */
	punpcklwd %mm5, %mm4	/* GECA1GECA0 */
	punpcklwd %mm7, %mm6	/* BDFH1BDFH0 */
	punpckhdq %mm6, %mm4	/* BDFHGECA1 */
	pcmpeqb	%mm0, %mm4
	pand	k3-16(%esi), %mm4
	
	movd	%mm4, %eax
	punpckhdq %mm4, %mm4
	testl	%eax, %eax
	movd	%mm4, %ebx
	jnz	ultracycle
	testl	%ebx, %ebx
	jnz	ultracycle

	jmp	mainloop

ultracycle:
	movl	$19, %eax
	movq	k3-8(%esi), %mm7
	pushl	$32
	leal	v2(%esi), %ecx
	pushl	%ecx
	leal	fkeep(%esi), %edi
	pushl	%edi
	leal	k1(%esi), %ebx
	pushl	%ebx
	call	mmx_rcxor
	addl	$16, %esp

	leal	v1(%esi), %ebx
	
	movq	(%ebx), %mm0
	movq	32(%ebx), %mm1
	movq	64(%ebx), %mm2
	movq	96(%ebx), %mm3
	movq	%mm0, %mm4	/* CA3210 */
	punpckhdq %mm0, %mm0	/* CC3210 */
	movq	%mm1, %mm5	/* GE3210 */
	punpckhdq %mm1, %mm1	/* GG3210 */
	movq	%mm2, %mm6	/* FH3210 */
	punpckhdq %mm2, %mm2	/* FF3210 */
	movq	%mm3, %mm7	/* BD3210 */
	punpckhdq %mm3, %mm3	/* BB3210 */
	punpcklbw %mm0, %mm4	/* CA3CA2CA1CA0 */
	punpcklbw %mm1, %mm5	/* GE3GE2GE1GE0 */
	punpcklbw %mm2, %mm6	/* FH3FH2FH1FH0 */
	punpcklbw %mm3, %mm7	/* BD3BD2BD1BD0 */
	movq	%mm4, %mm0
	movq	%mm6, %mm2
	punpcklwd %mm5, %mm0	/* GECA1GECA0 */
	punpcklwd %mm7, %mm2    /* BDFH1BDFH0 */
	punpckhwd %mm5, %mm4	/* GECA3GECA2 */
	punpckhwd %mm7, %mm6	/* BDFH3BDFH2 */
	movq	%mm0, %mm1
	movq	%mm4, %mm5
	punpckldq %mm2, %mm0	/* BDFHGECA0 */
	punpckhdq %mm2, %mm1    /* BDFHGECA1 */
	punpckldq %mm6, %mm4	/* BDFHGECA2 */
	punpckhdq %mm6, %mm5    /* BDFHGECA3 */
	pcmpeqb	k2(%esi), %mm0
	pcmpeqb	k2+8(%esi), %mm1
	pcmpeqb	k2+16(%esi), %mm4
	pcmpeqb	k2+24(%esi), %mm5
	pand	%mm0, %mm1
	pand	%mm4, %mm5
	pand	%mm1, %mm5
	movq	%mm5, (%esi)

	movq	8(%ebx), %mm0
	movq	40(%ebx), %mm1
	movq	72(%ebx), %mm2
	movq	104(%ebx), %mm3
	movq	%mm0, %mm4
	punpckhdq %mm0, %mm0
	movq	%mm1, %mm5
	punpckhdq %mm1, %mm1
	movq	%mm2, %mm6
	punpckhdq %mm2, %mm2
	movq	%mm3, %mm7
	punpckhdq %mm3, %mm3
	punpcklbw %mm0, %mm4
	punpcklbw %mm1, %mm5
	punpcklbw %mm2, %mm6
	punpcklbw %mm3, %mm7
	movq	%mm4, %mm0
	movq	%mm6, %mm2
	punpcklwd %mm5, %mm0
	punpcklwd %mm7, %mm2
	punpckhwd %mm5, %mm4
	punpckhwd %mm7, %mm6
	movq	%mm0, %mm1
	movq	%mm4, %mm5
	punpckldq %mm2, %mm0
	punpckhdq %mm2, %mm1
	punpckldq %mm6, %mm4
	punpckhdq %mm6, %mm5
	pcmpeqb	k2+32(%esi), %mm0
	pcmpeqb	k2+40(%esi), %mm1
	pcmpeqb	k2+48(%esi), %mm4
	pcmpeqb	k2+56(%esi), %mm5
	movq	(%esi), %mm6
	pand	%mm0, %mm1
	pand	%mm4, %mm5
	pand	%mm1, %mm5
	pand	%mm6, %mm5
	movq	%mm5, (%esi)

	movq	16(%ebx), %mm0
	movq	48(%ebx), %mm1
	movq	80(%ebx), %mm2
	movq	112(%ebx), %mm3
	movq	%mm0, %mm4
	punpckhdq %mm0, %mm0
	movq	%mm1, %mm5
	punpckhdq %mm1, %mm1
	movq	%mm2, %mm6
	punpckhdq %mm2, %mm2
	movq	%mm3, %mm7
	punpckhdq %mm3, %mm3
	punpcklbw %mm0, %mm4
	punpcklbw %mm1, %mm5
	punpcklbw %mm2, %mm6
	punpcklbw %mm3, %mm7
	movq	%mm4, %mm0
	movq	%mm6, %mm2
	punpcklwd %mm5, %mm0
	punpcklwd %mm7, %mm2
	punpckhwd %mm5, %mm4
	punpckhwd %mm7, %mm6
	movq	%mm0, %mm1
	movq	%mm4, %mm5
	punpckldq %mm2, %mm0
	punpckhdq %mm2, %mm1
	punpckldq %mm6, %mm4
	punpckhdq %mm6, %mm5
	pcmpeqb	k2+64(%esi), %mm0
	pcmpeqb	k2+72(%esi), %mm1
	pcmpeqb	k2+80(%esi), %mm4
	pcmpeqb	k2+88(%esi), %mm5
	movq	(%esi), %mm6
	pand	%mm0, %mm1
	pand	%mm4, %mm5
	pand	%mm1, %mm5
	pand	%mm6, %mm5
	movq	%mm5, (%esi)

	movq	24(%ebx), %mm0
	movq	56(%ebx), %mm1
	movq	88(%ebx), %mm2
	movq	120(%ebx), %mm3
	movq	%mm0, %mm4
	punpckhdq %mm0, %mm0
	movq	%mm1, %mm5
	punpckhdq %mm1, %mm1
	movq	%mm2, %mm6
	punpckhdq %mm2, %mm2
	movq	%mm3, %mm7
	punpckhdq %mm3, %mm3
	punpcklbw %mm0, %mm4
	punpcklbw %mm1, %mm5
	punpcklbw %mm2, %mm6
	punpcklbw %mm3, %mm7
	movq	%mm4, %mm0
	movq	%mm6, %mm2
	punpcklwd %mm5, %mm0
	punpcklwd %mm7, %mm2
	punpckhwd %mm5, %mm4
	punpckhwd %mm7, %mm6
	movq	%mm0, %mm1
	movq	%mm4, %mm5
	punpckldq %mm2, %mm0
	punpckhdq %mm2, %mm1
	punpckldq %mm6, %mm4
	punpckhdq %mm6, %mm5
	pcmpeqb	k2+96(%esi), %mm0
	pcmpeqb	k2+104(%esi), %mm1
	pcmpeqb	k2+112(%esi), %mm4
	pcmpeqb	k2+120(%esi), %mm5
	movq	(%esi), %mm6
	pand	%mm0, %mm1
	pand	%mm4, %mm5
	pand	%mm1, %mm5
	pand	%mm6, %mm5
	movq	%mm5, (%esi)

	movd	%mm5, %eax
	punpckhdq %mm5, %mm5
	testl	%eax, %eax
	movd	%mm5, %ebx
	jnz	find_pwd
	testl	%ebx, %ebx
	jnz	find_pwd

	jmp	mainloop
	
	

part_mmxcrk:
	xorl	%eax, %eax
	jmp	end_crk

find_pwd:
	movl	$1, %eax
end_crk:
	popl	%ebp /* (name strlen + 1) */
	
	popl	%ebp
	popl	%edi
	popl	%esi
	popl	%edx
	popl	%ecx
	popl	%ebx

	ret
