/*
    pwl9x "Windows 9x PassWord List reader"
    Copyright (C) 2001 Knispel Guillaume

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

.section .rodata
.align 16
sinsalt:
	.int -0x28955b88, -0x28955b88
	.int -0x173848AA, -0x173848AA
	.int 0x242070DB, 0x242070DB
	.int -0x3E423112, -0x3E423112
	.int -0x0A83F051, -0x0A83F051
	.int 0x4787C62A, 0x4787C62A
	.int -0x57CFB9ED, -0x57CFB9ED
	.int -0x02B96AFF, -0x02B96AFF
	.int 0x698098D8, 0x698098D8
	.int -0x74BB0851, -0x74BB0851
	.int -0x0000A44F, -0x0000A44F
	.int -0x76A32842, -0x76A32842
	.int 0x6B901122, 0x6B901122
	.int -0x02678E6D, -0x02678E6D
	.int -0x5986BC72, -0x5986BC72
	.int 0x49B40821, 0x49B40821

	.int -0x09E1DA9E, -0x09E1DA9E
	.int -0x3FBF4CC0, -0x3FBF4CC0
	.int 0x265E5A51, 0x265E5A51
	.int -0x16493856, -0x16493856
	.int -0x29D0EFA3, -0x29D0EFA3
	.int 0x02441453, 0x02441453
	.int -0x275E197F, -0x275E197F
	.int -0x182C0438, -0x182C0438
	.int 0x21E1CDE6, 0x21E1CDE6
	.int -0x3CC8F82A, -0x3CC8F82A
	.int -0x0B2AF279, -0x0B2AF279
	.int 0x455A14ED, 0x455A14ED
	.int -0x561C16FB, -0x561C16FB
	.int -0x03105C08, -0x03105C08
	.int 0x676F02D9, 0x676F02D9
	.int -0x72D5B376, -0x72D5B376

	.int -0x0005C6BE, -0x0005C6BE
	.int -0x788E097F, -0x788E097F
	.int 0x6D9D6122, 0x6D9D6122
	.int -0x021AC7F4, -0x021AC7F4
	.int -0x5B4115BC, -0x5B4115BC
	.int 0x4BDECFA9, 0x4BDECFA9
	.int -0x0944B4A0, -0x0944B4A0
	.int -0x41404390, -0x41404390
	.int 0x289B7EC6, 0x289B7EC6
	.int -0x155ED806, -0x155ED806
	.int -0x2B10CF7B, -0x2B10CF7B
	.int 0x04881D05, 0x04881D05
	.int -0x262B2FC7, -0x262B2FC7
	.int -0x1924661B, -0x1924661B
	.int 0x1FA27CF8, 0x1FA27CF8
	.int -0x3B53A99B, -0x3B53A99B

	.int -0x0BD6DDBC, -0x0BD6DDBC
	.int 0x432AFF97, 0x432AFF97
	.int -0x546BDC59, -0x546BDC59
	.int -0x036C5FC7, -0x036C5FC7
	.int 0x655B59C3, 0x655B59C3
	.int -0x70F3336E, -0x70F3336E
	.int -0x00100B83, -0x00100B83
	.int -0x7A7BA22F, -0x7A7BA22F
	.int 0x6FA87E4F, 0x6FA87E4F
	.int -0x01D31920, -0x01D31920
	.int -0x5CFEBCEC, -0x5CFEBCEC
	.int 0x4E0811A1, 0x4E0811A1
	.int -0x08AC817E, -0x08AC817E
	.int -0x42C50DCB, -0x42C50DCB
	.int 0x2AD7D2BB, 0x2AD7D2BB
	.int -0x14792C6F, -0x14792C6F

.text
	
#define p1	%mm0
#define p2	%mm1
#define p3	%mm2
#define p4	%mm3
#define t1	%mm4
#define t2	%mm5
#define s1	%mm6
#define	s2	%mm7

#define MD5_FF(A,B,C,D,T1,T2,S1,S2,R,PA,I) \
	pand	B, T1		; \
	pxor	D, T1		; \
	movq	C, S1		; \
	paddd	PA(%eax), D	; \
	paddd	T1, A		; \
	movq	A, T2		; \
	pslld	$(R), A		; \
	psrld	$(32-R), T2	; \
	pxor	B, S1		; \
	paddd	sinsalt+I, D	; \
	por	T2, A		; \
	paddd	B, A

#define MD5_GG(A,B,C,D,T1,T2,S1,S2,R,PA,I) \
	paddd	PA(%eax), D	; \
	pand	B, T2		; \
	movq	C, S1		; \
	por	T1, T2		; \
	movq	C, S2		; \
	paddd	T2, A		; \
	movq	A, T1		; \
	pslld	$(R), A		; \
	psrld	$(32-R), T1	; \
	paddd	sinsalt+I, D	; \
	pandn	B, S1		; \
	por	T1, A		; \
	paddd	B, A

#define MD5_HH(A,B,C,D,T1,T2,S1,S2,R,PA,I) \
	paddd	PA(%eax), D	; \
	pxor	B, T1		; \
	movq	C, S1		; \
	paddd	T1, A		; \
	movq	A, T2		; \
	pslld	$(R), A		; \
	paddd	sinsalt+I, D	; \
	psrld	$(32-R), T2	; \
	pxor	B, S1		; \
	por	T2, A		; \
	paddd	B, A

#define MD5_II(A,B,C,D,T1,T2,S1,S2,R,PA,I) \
	por	B, T1		; \
	pxor	C, T1		; \
	movq	C, S1		; \
	paddd	PA(%eax), D	; \
	paddd	T1, A		; \
	movq	A, %mm5		; \
	pslld	$(R), A		; \
	psrld	$(32-R), %mm5	; \
	pxor	%mm7, S1	; \
	paddd	sinsalt+I, D	; \
	por	%mm5, A		; \
	paddd	B, A

/* int mmx_h_md5(char source[128], char dest[32]); */	
	.align 16
	.globl mmx_h_md5
mmx_h_md5:
	movl	$0xd76aa477, %eax
	movl	$0xf8fa0bcc, %ebp
	movd	%eax, p1
	movl	4(%esp), %eax
	movd	%ebp, p4
	punpckldq p1, p1
	movl	$0x98BADCFE, %ebp
	punpckldq p4, p4
	movd	%ebp, p3
	punpckldq p3, p3
	movl	$0xEFCDAB89, %ebp
	movq	p3, s1
        paddd   (%eax), p1
	movd	%ebp, p2
	punpckldq p2, p2

	paddd	8(%eax), p4
	movq	p1, t2
	pslld	$(7), p1
	psrld	$(32-7), t2
	pxor	p2, s1
	por	t2, p1
	paddd	p2, p1
	
/*	MD5_FF(p1,p2,p3,p4,t1,t2,s1,s2, 7, 1*8, 1*8)*/
	MD5_FF(p4,p1,p2,p3,s1,s2,t1,t2,12, 2*8, 2*8)
	MD5_FF(p3,p4,p1,p2,t1,t2,s1,s2,17, 3*8, 3*8)
	MD5_FF(p2,p3,p4,p1,s1,s2,t1,t2,22, 4*8, 4*8)
	MD5_FF(p1,p2,p3,p4,t1,t2,s1,s2, 7, 5*8, 5*8)
	MD5_FF(p4,p1,p2,p3,s1,s2,t1,t2,12, 6*8, 6*8)
	MD5_FF(p3,p4,p1,p2,t1,t2,s1,s2,17, 7*8, 7*8)
	MD5_FF(p2,p3,p4,p1,s1,s2,t1,t2,22, 8*8, 8*8)
	MD5_FF(p1,p2,p3,p4,t1,t2,s1,s2, 7, 9*8, 9*8)
	MD5_FF(p4,p1,p2,p3,s1,s2,t1,t2,12,10*8,10*8)
	MD5_FF(p3,p4,p1,p2,t1,t2,s1,s2,17,11*8,11*8)
	MD5_FF(p2,p3,p4,p1,s1,s2,t1,t2,22,12*8,12*8)
	MD5_FF(p1,p2,p3,p4,t1,t2,s1,s2, 7,13*8,13*8)
	MD5_FF(p4,p1,p2,p3,s1,s2,t1,t2,12,14*8,14*8)
	MD5_FF(p3,p4,p1,p2,t1,t2,s1,s2,17,15*8,15*8)
/*	MD5_FF(p2,p3,p4,p1,s1,s2,t1,t2,22, 1*8,16*8)*/
        pand %mm2, %mm6 ; pxor %mm0, %mm6 ; paddd 1*8(%eax), %mm0 ; paddd %mm6, %mm1 ; movq %mm1, %mm7 ; pslld $(22), %mm1 ; psrld $(32-22), %mm7 ; paddd sinsalt+16*8, %mm0 ; por %mm7, %mm1 ; paddd %mm2, %mm1

	movq p4, t1
	movq p4, t2
	pandn	p3, t1

	MD5_GG(p1,p2,p3,p4,t1,t2,s1,s2, 5, 6*8,17*8)
	MD5_GG(p4,p1,p2,p3,s1,s2,t1,t2, 9,11*8,18*8)
	MD5_GG(p3,p4,p1,p2,t1,t2,s1,s2,14, 0*8,19*8)
	MD5_GG(p2,p3,p4,p1,s1,s2,t1,t2,20, 5*8,20*8)
	MD5_GG(p1,p2,p3,p4,t1,t2,s1,s2, 5,10*8,21*8)
	MD5_GG(p4,p1,p2,p3,s1,s2,t1,t2, 9,15*8,22*8)
	MD5_GG(p3,p4,p1,p2,t1,t2,s1,s2,14, 4*8,23*8)
	MD5_GG(p2,p3,p4,p1,s1,s2,t1,t2,20, 9*8,24*8)
	MD5_GG(p1,p2,p3,p4,t1,t2,s1,s2, 5,14*8,25*8)
	MD5_GG(p4,p1,p2,p3,s1,s2,t1,t2, 9, 3*8,26*8)
	MD5_GG(p3,p4,p1,p2,t1,t2,s1,s2,14, 8*8,27*8)
	MD5_GG(p2,p3,p4,p1,s1,s2,t1,t2,20,13*8,28*8)
	MD5_GG(p1,p2,p3,p4,t1,t2,s1,s2, 5, 2*8,29*8)
	MD5_GG(p4,p1,p2,p3,s1,s2,t1,t2, 9, 7*8,30*8)
	MD5_GG(p3,p4,p1,p2,t1,t2,s1,s2,14,12*8,31*8)
/*	MD5_GG(p2,p3,p4,p1,s1,s2,t1,t2,20, 5*8,32*8)*/
        paddd 5*8(%eax), %mm0 ; pand %mm2, %mm7 ;  por %mm6, %mm7 ; paddd %mm7, %mm1 ; movq %mm1, %mm6 ; pslld $(20), %mm1 ; psrld $(32-20), %mm6 ; paddd sinsalt+32*8, %mm0 ; por %mm6, %mm1

	movq p4, t1
	paddd %mm2, %mm1
	pxor p3, t1

	MD5_HH(p1,p2,p3,p4,t1,t2,s1,s2, 4, 8*8,33*8)
	MD5_HH(p4,p1,p2,p3,s1,s2,t1,t2,11,11*8,34*8)
	MD5_HH(p3,p4,p1,p2,t1,t2,s1,s2,16,14*8,35*8)
	MD5_HH(p2,p3,p4,p1,s1,s2,t1,t2,23, 1*8,36*8)
	MD5_HH(p1,p2,p3,p4,t1,t2,s1,s2, 4, 4*8,37*8)
	MD5_HH(p4,p1,p2,p3,s1,s2,t1,t2,11, 7*8,38*8)
	MD5_HH(p3,p4,p1,p2,t1,t2,s1,s2,16,10*8,39*8)
	MD5_HH(p2,p3,p4,p1,s1,s2,t1,t2,23,13*8,40*8)
	MD5_HH(p1,p2,p3,p4,t1,t2,s1,s2, 4, 0*8,41*8)
	MD5_HH(p4,p1,p2,p3,s1,s2,t1,t2,11, 3*8,42*8)
	MD5_HH(p3,p4,p1,p2,t1,t2,s1,s2,16, 6*8,43*8)
	MD5_HH(p2,p3,p4,p1,s1,s2,t1,t2,23, 9*8,44*8)
	MD5_HH(p1,p2,p3,p4,t1,t2,s1,s2, 4,12*8,45*8)
	MD5_HH(p4,p1,p2,p3,s1,s2,t1,t2,11,15*8,46*8)
	MD5_HH(p3,p4,p1,p2,t1,t2,s1,s2,16, 2*8,47*8)
/*	MD5_HH(p2,p3,p4,p1,s1,s2,t1,t2,23, 0*8,48*8)*/
        paddd 0*8(%eax), %mm0 ; pxor %mm2, %mm6 ; paddd %mm6, %mm1 ; movq %mm1, %mm7 ; pslld $(23), %mm1 ; paddd sinsalt+48*8, %mm0 ; psrld $(32-23), %mm7 ; por %mm7, %mm1 ; paddd %mm2, %mm1

	pcmpeqb	%mm7, %mm7
	movq p4, t1
	pxor	%mm7, t1

	MD5_II(p1,p2,p3,p4,t1,t2,s1,s2, 6, 7*8,49*8)
	MD5_II(p4,p1,p2,p3,s1,s2,t1,t2,10,14*8,50*8)
	MD5_II(p3,p4,p1,p2,t1,t2,s1,s2,15, 5*8,51*8)
	MD5_II(p2,p3,p4,p1,s1,s2,t1,t2,21,12*8,52*8)
	MD5_II(p1,p2,p3,p4,t1,t2,s1,s2, 6, 3*8,53*8)
	MD5_II(p4,p1,p2,p3,s1,s2,t1,t2,10,10*8,54*8)
	MD5_II(p3,p4,p1,p2,t1,t2,s1,s2,15, 1*8,55*8)
	MD5_II(p2,p3,p4,p1,s1,s2,t1,t2,21, 8*8,56*8)
	MD5_II(p1,p2,p3,p4,t1,t2,s1,s2, 6,15*8,57*8)
	MD5_II(p4,p1,p2,p3,s1,s2,t1,t2,10, 6*8,58*8)
	MD5_II(p3,p4,p1,p2,t1,t2,s1,s2,15,13*8,59*8)
	MD5_II(p2,p3,p4,p1,s1,s2,t1,t2,21, 4*8,60*8)
	MD5_II(p1,p2,p3,p4,t1,t2,s1,s2, 6,11*8,61*8)
	MD5_II(p4,p1,p2,p3,s1,s2,t1,t2,10, 2*8,62*8)
	MD5_II(p3,p4,p1,p2,t1,t2,s1,s2,15, 9*8,63*8)
/*	MD5_II(p2,p3,p4,p1,s1,s2,t1,t2,21,15*8,64*8)*/
        por %mm2, %mm6 ; pxor %mm3, %mm6 ; paddd %mm6, %mm1 ; movq %mm1, %mm5 ; pslld $(21), %mm1 ; psrld $(32-21), %mm5 ; por %mm5, %mm1 ; paddd %mm2, %mm1

	movl	$0x67452301, %eax
	pcmpeqb	s1, s1
	movd	%eax, t1
	movl	$0xefcdab89, %eax
	pcmpeqb s2, s2
	movd	%eax, t2
	punpckldq t1, t1
	movl	8(%esp), %eax
	punpckldq t2, t2
	paddd	t1, p1
	paddd	t2, p2
	psubb	t1, s1
	psubb	t2, s2	
	movq	p1, (%eax)
	movq	p2, 8(%eax)
	paddd	s1, p3
	paddd	s2, p4
	movq	p3, 16(%eax)
	movq	p4, 24(%eax)
	
	ret	
