/*
    pwl9x "Windows 9x PassWord List reader"
    Copyright (C) 2001 Knispel Guillaume

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <stdio.h>
#include <string.h>

#define LNSZ 1024

int main(int argc, char *argv[])
{
  int i, sz;
  FILE *data; FILE *upper;
  char line[LNSZ], *nextsemicolon, *scan;

  fprintf(stderr, "data2upper extracts upper case mapping informations\n"\
                  "from the Unicode Character Database available at\n"\
	          "\"http://www.unicode.org/Public/UNIDATA/UnicodeData.txt\"\n"\
	          "This utility is part of Windows 9x PassWord List reader\n"\
	          "[pwl9x v0.07] (C) 2001 Xilun.\n\n");

  if (argc != 3) { fprintf(stderr, "usage : data2upper UnicodeData.txt UnicodeUpper.txt\n"); return 1; }
  if ((data = fopen(argv[1], "rt")) == NULL) { fprintf(stderr, "Unable to open the unicode data file \"%s\" for reading text\n", argv[1]); return 2; }
  if ((upper = fopen (argv[2], "wt")) == NULL) { fprintf(stderr, "Unable to open the output file \"%s\" for writing text\n", argv[2]); return 3; }

  fprintf(upper, "# These informations are extracted from the Unicode Character Database\n"\
	         "# available at \"http://www.unicode.org/Public/UNIDATA/UnicodeData.txt\"\n"\
	         "# It contains the field 0 \'Code Value\' and 12 \'Uppercase Mapping\',\n"\
	         "# space separated, of Unicode Characters having an upper case equivalent\n"\
	         "# mapping.\n\n");

  while(fgets(line, LNSZ, data) != NULL) {
    if (*line) {
      nextsemicolon = line;
      for (i = 0; i < 12 && nextsemicolon; nextsemicolon++, i++) nextsemicolon = strchr(nextsemicolon, ';');
      if (nextsemicolon == NULL || *nextsemicolon == ';') continue;
      scan = strchr(line, ';');
      *scan++ = ' ';
      memmove(scan, nextsemicolon, sz = strchr(nextsemicolon, ';') - nextsemicolon);
      scan[sz] = '\n'; scan[sz+1] = 0;
      fputs(line, upper);
    }
  }

  fclose(data);
  fclose(upper);

  return 0;
}
