/*
    pwl9x "Windows 9x PassWord List reader"
    Copyright (C) 2001 Knispel Guillaume

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>

#include "defs.h"
#include "x86.h"
#include "crk.h"

void try_crack_pwl_x86(Params *p, Pwl *pwl)
{
  int i, k, n; x86workspace *buff8al;
  char buff[sizeof(x86workspace)+8];
  
  buff8al = (x86workspace *)((((unsigned int)buff) + 7) & ~7);
  n = crk_start((int (*)(paramspace *))x86crk, (paramspace *)buff8al,
		sizeof(x86workspace), p, pwl, (dword *)(buff8al));
  if (n==-1) return;

  if (p->have_pwd || p->interrupted) {
    if (!(p->pwd = malloc(n--))) { fprintf(stderr, "Could not allocate enough memory.\n"); exit(EMEM); }

    strcpy(p->pwd, buff8al->x86spc);
    if (p->have_pwd) {
      k = buff8al->alq;

      if (n) while (k--) {
        char *linc = buff8al->incr; int r, s = 0;
        do {
	  r = p->pwd[s];
	  for (i = 1; (i < 256) && (p->pwd[s] != linc[i]); i++); p->pwd[s] = i;
	  s++;
        } while (i >= r && s < n);
      }
    }

    printf(p->have_pwd?"The main password seems to be \"%s\"\n\n":
		       "The next password to check is \"%s\"\n\n", p->pwd);
  } else printf("The main password has not been found\n");
}
