/*
    pwl9x "Windows 9x PassWord List reader"
    Copyright (C) 2001 Knispel Guillaume

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

	.text

#define salt	0
#define sign	8
#define check	24
#define name	40
#define pwd	80
#define incr	120
#define mdpwd   376
#define mdchk	440
#define mdres   504
#define rctab1	520
#define rctab2	776
#define rckey1  1032
#define rckey2	1048
#define unchk1	1064
#define unchk2	1096
#define enbuf	1128

	.align 16
incrby1:
	xorl	%eax, %eax
inc1char:
	movzbl	mdpwd(%esi,%eax), %ebx
	incl	%eax
	cmpl	%eax, %ebp
	movzbl	incr(%esi,%ebx), %ecx
	je	endspc
	cmpb	%cl, %bl
	movb	%cl, mdpwd-1(%esi,%eax)
	jb	endinc
	jmp	inc1char
endspc:
	movl	$0x55AA55AA, (%esi)
endinc:
	ret

	.align 16
	.globl x86crk
x86crk:
	pushl	%ebx
	pushl	%ebp
	pushl	%esi
	pushl	%edi

	movl	20(%esp), %esi
	movl	$-1, mdchk-4(%esi)	/* put -1 */
	movl	salt(%esi), %ebx

	xorl	%eax, %eax		/* strlen(name) + 1 */
	leal	name(%esi), %edi
	movl	$40, %ecx
	repne
	scasb
	subl	$40, %ecx
	neg	%ecx
	movl	%ecx, %edx

	pushl	%esi			/* copy name */
	leal	mdchk(%esi), %edi
	leal	name(%esi), %esi
	rep
	movsb
	popl	%esi

	xorl	%eax, %eax		/* strlen(pwd) + 1 */
	leal	pwd(%esi), %edi
	movl	$40, %ecx
	repne
	scasb
	subl	$40, %ecx
	neg	%ecx

	movl	%ebx, mdchk(%esi, %edx)	/* copy salt */
	movb	$0x80, mdchk+4(%esi, %edx) /* put final bit */

	leal	64(,%edx,8), %ebx	/* compute, save & put mdsize */
	movl	%ebx, mdchk+52(%esi)

	leal	mdpwd(%esi, %ecx), %eax	/* md5 result just after pwd */
	pushl	%eax
	leal	mdchk-4(%esi), %eax	/* md5 buffer */
	pushl	%eax
	call	x86_h_md5		/* compute first outloop md5 */
	addl	$8, %esp

	movl	$0, mdchk+52(%esi)	/* raz first mdsize */
	addl	$64, %ebx		/* first mdsize + 64 = */
	movl	%ebx, mdchk+56(%esi)	/* last mdsize (inloop) */
	movb	$0x80, mdchk+16(%esi, %edx) /* put final bit */

	pushl	%esi			/* copy pwd */
	movl	%ecx, %ebp		/* but keep strlen(pwd)+1 alive */
	leal	mdpwd(%esi), %edi
	leal	pwd(%esi), %esi
	rep
	movsb
	popl	%esi

	leal	128(,%ebp,8), %eax	/* compute & put mid mdsize */
	movl	%eax, mdpwd+56(%esi)
	movl	$0, mdpwd+60(%esi)	/* was -1 for first md5 h */
	movb	$0x80, mdpwd+16(%esi, %ebp) /* put final bit */

	movl	$0, (%esi)		/* end of crack space marker */
	movl	$0, 4(%esi)

/*********************************/
	/* MAIN LOOP */
/*********************************/
	.p2align 4
mainloop:
	cmpl	$0x55AA55AA, (%esi)	/* end of crack space ? */
	je	part_x86crk		/* |--> exit */

	leal	rckey1(%esi), %ecx	/* compute two mid md5 h */
	leal	mdpwd(%esi), %eax
	pushl	%ecx
	addl	$16, %ecx
	pushl	%eax
	call	x86_h_md5
	movl	%ecx, 4(%esp)
	call	incrby1
	call	x86_h_md5
	call	incrby1
	addl	$8, %esp

	leal	rctab1(%esi), %eax	/* compute two un-rc4 of sign */
	pushl	%eax			/* and first byte of check */
	call	x86_mkxor		/* with key = result of mid md5 */
	addl	$4, %esp
	pushl	$17
	movl	$1, %edi
	xorl	%ebx, %ebx
	xorl	%ecx, %ecx
	call	x86_rcxor
	addl	$4, %esp

	pushl	%ebx			/* copy decrypted sign and compute */
	pushl	%ecx			/* the final md5, 2 times */
	movl	unchk1(%esi), %eax	/* we pushl %ebx and %ecx because */
	movl	unchk1+4(%esi), %ebx	/* they are the rc4 counters and */
	movl	unchk1+8(%esi), %ecx	/* may be used to decrypt the */
	movl	%eax, mdchk(%esi,%edx)	/* remaining of check if its first */
	movl	unchk1+12(%esi), %edi	/* byte match */
	movl	%ebx, mdchk+4(%esi,%edx)
	leal	rckey1(%esi), %ebx
	movl	%ecx, mdchk+8(%esi,%edx)
	leal	mdchk(%esi), %eax
	movl	%edi, mdchk+12(%esi,%edx)
	pushl	%ebx
	addl	$16, %ebx
	pushl	%eax
	call	x86_h_md5
	movl	%ebx, 4(%esp)
	movl	unchk2(%esi), %eax
	movl	unchk2+4(%esi), %ebx
	movl	unchk2+8(%esi), %ecx
	movl	%eax, mdchk(%esi,%edx)
	movl	unchk2+12(%esi), %edi
	movl	%ebx, mdchk+4(%esi,%edx)
	movl	%ecx, mdchk+8(%esi,%edx)
	movl	%edi, mdchk+12(%esi,%edx)
	call	x86_h_md5
	movb	unchk1+16(%esi), %cl
	movb	unchk2+16(%esi), %ch
	cmpb	rckey1(%esi), %cl
	je	ultim_cycle
	cmpb	rckey2(%esi), %ch
	je	ultim_cycle

	addl	$16, %esp

	jmp	mainloop		/* hum... loop ! ;) */

ultim_cycle:
	addl	$8, %esp
	popl	%ecx			/* restore rc4 decryption params */
	popl	%ebx
	pushl	$32
	movl	$18, %edi
	call	x86_rcxor		/* and decrypt remaining part */
	addl	$4, %esp		/* of check */

	pushl	%esi			/* compare result 1 */
	movl	$4, %ecx
	leal	unchk1+16(%esi), %edi
	leal	rckey1(%esi), %esi
	repe
	cmpsl
	popl	%esi
	movl	$2, 4(%esi)
	je	find_pwd

	pushl	%esi			/* compare result 2 */
	movl	$4, %ecx
	leal	unchk2+16(%esi), %edi
	leal	rckey2(%esi), %esi
	repe
	cmpsl
	popl	%esi
	movl	$1, 4(%esi)
	je	find_pwd

	jmp	mainloop


part_x86crk:
	xorl	%eax, %eax
	jmp	end_crk
find_pwd:
	movl	$1, %eax
end_crk:
	popl	%edi
	popl	%esi
	popl	%ebp
	popl	%ebx

	ret
