/*
    pwl9x "Windows 9x PassWord List reader"
    Copyright (C) 2001 Knispel Guillaume

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

	.text

/* rc4-128 x2 initialisation :
	unsigned char everything, rctab[256]; int i, j;
	for (i=0;i<256;i++) rctab[i] = i; --> completly unlooped
	j=0; --> %ebx for first rc4, %ecx for second
	for (i=0;i<256;i++) { --> unlooped
		j+=rctab[i]+rckey[i&0xf]; > rctab1[i] in %al, rctab2[i] in %dl
		j&=0xff;		  > i&0xf staticaly calculated (unloop)
		t=rctab[i];		  > rckey1[i&f] in %edi
		rctab[i]=rctab[j];	  > rckey2[i&f] in %ebp
		rctab[j]=t;		  > rctab1[j1] in %ah, rctab2[j2] in %dh
	}
*/

#define ITER_X2(i) \
	addb	%al, %bl; \
	addb	%dl, %cl; \
	movzbl	%bl, %ebx; \
	movzbl	%cl, %ebx; \
	addl	%edi, %ebx; \
	addl	%ebp, %ecx; \
	movzbl	0x200+(((i)+1) & 0xf)(%esi), %edi; \
	andl	$0xFF, %ebx; \
	andl	$0xFF, %ecx; \
	movzbl	0x210+(((i)+1) & 0xf)(%esi), %ebp; \
	movb	(%esi, %ebx), %ah; \
	movb	0x100(%esi, %ecx), %dh; \
	movb	%al, (%esi, %ebx); \
	movb	1+(i)(%esi), %al; \
	movb	%dl, 0x100(%esi, %ecx); \
	movb	0x101+(i)(%esi), %dl; \
	movb	%ah, (i)(%esi); \
	movb	%dh, 0x100+(i)(%esi)

#define N16ITER(i) \
	ITER_X2(i);    ITER_X2(i+1);  ITER_X2(i+2);  ITER_X2(i+3);\
	ITER_X2(i+4);  ITER_X2(i+5);  ITER_X2(i+6);  ITER_X2(i+7);\
	ITER_X2(i+8);  ITER_X2(i+9);  ITER_X2(i+10); ITER_X2(i+11);\
	ITER_X2(i+12); ITER_X2(i+13); ITER_X2(i+14); ITER_X2(i+15)

	.align 16
	.globl x86_mkxor
x86_mkxor:
	pushl	%ecx
	pushl	%edx
	pushl	%ebx
	pushl	%ebp
	pushl	%esi
	pushl	%edi

	movl	28(%esp), %esi
	xorl	%eax, %eax
	xorl	%ebx, %ebx
	xorl	%ecx, %ecx
	xorl	%edx, %edx
	xorl	%edi, %edi
	xorl	%ebp, %ebp
	addl	$0x80, %esi

       	movl	$0x03020100, -128(%esi)
	movl	$0x07060504, -124(%esi)
	movl	$0x0b0a0908, -120(%esi)
	movl	$0x0f0e0d0c, -116(%esi)
	movl	$0x13121110, -112(%esi)
	movl	$0x17161514, -108(%esi)
	movl	$0x1b1a1918, -104(%esi)
	movl	$0x1f1e1d1c, -100(%esi)
	movl	$0x23222120, -96(%esi)
	movl	$0x27262524, -92(%esi)
	movl	$0x2b2a2928, -88(%esi)
	movl	$0x2f2e2d2c, -84(%esi)
	movl	$0x33323130, -80(%esi)
	movl	$0x37363534, -76(%esi)
	movl	$0x3b3a3938, -72(%esi)
	movl	$0x3f3e3d3c, -68(%esi)
	movl	$0x43424140, -64(%esi)
	movl	$0x47464544, -60(%esi)
	movl	$0x4b4a4948, -56(%esi)
	movl	$0x4f4e4d4c, -52(%esi)
	movl	$0x53525150, -48(%esi)
	movl	$0x57565554, -44(%esi)
	movl	$0x5b5a5958, -40(%esi)
	movl	$0x5f5e5d5c, -36(%esi)
	movl	$0x63626160, -32(%esi)
	movl	$0x67666564, -28(%esi)
	movl	$0x6b6a6968, -24(%esi)
	movl	$0x6f6e6d6c, -20(%esi)
	movl	$0x73727170, -16(%esi)
	movl	$0x77767574, -12(%esi)
	movl	$0x7b7a7978, -8(%esi)
	movl	$0x7f7e7d7c, -4(%esi)
	movl	$0x83828180, 0(%esi)
	movl	$0x87868584, 4(%esi)
	movl	$0x8b8a8988, 8(%esi)
	movl	$0x8f8e8d8c, 12(%esi)
	movl	$0x93929190, 16(%esi)
	movl	$0x97969594, 20(%esi)
	movl	$0x9b9a9998, 24(%esi)
	movl	$0x9f9e9d9c, 28(%esi)
	movl	$0xa3a2a1a0, 32(%esi)
	movl	$0xa7a6a5a4, 36(%esi)
	movl	$0xabaaa9a8, 40(%esi)
	movl	$0xafaeadac, 44(%esi)
	movl	$0xb3b2b1b0, 48(%esi)
	movl	$0xb7b6b5b4, 52(%esi)
	movl	$0xbbbab9b8, 56(%esi)
	movl	$0xbfbebdbc, 60(%esi)
	movl	$0xc3c2c1c0, 64(%esi)
	movl	$0xc7c6c5c4, 68(%esi)
	movl	$0xcbcac9c8, 72(%esi)
	movl	$0xcfcecdcc, 76(%esi)
	movl	$0xd3d2d1d0, 80(%esi)
	movl	$0xd7d6d5d4, 84(%esi)
	movl	$0xdbdad9d8, 88(%esi)
	movl	$0xdfdedddc, 92(%esi)
	movl	$0xe3e2e1e0, 96(%esi)
	movl	$0xe7e6e5e4, 100(%esi)
	movl	$0xebeae9e8, 104(%esi)
	movl	$0xefeeedec, 108(%esi)
	movl	$0xf3f2f1f0, 112(%esi)
	movl	$0xf7f6f5f4, 116(%esi)
	movl	$0xfbfaf9f8, 120(%esi)
	movl	$0xfffefdfc, 124(%esi)
	addl	$0x100, %esi
       	movl	$0x03020100, -128(%esi)
	movl	$0x07060504, -124(%esi)
	movl	$0x0b0a0908, -120(%esi)
	movl	$0x0f0e0d0c, -116(%esi)
	movl	$0x13121110, -112(%esi)
	movl	$0x17161514, -108(%esi)
	movl	$0x1b1a1918, -104(%esi)
	movl	$0x1f1e1d1c, -100(%esi)
	movl	$0x23222120, -96(%esi)
	movl	$0x27262524, -92(%esi)
	movl	$0x2b2a2928, -88(%esi)
	movl	$0x2f2e2d2c, -84(%esi)
	movl	$0x33323130, -80(%esi)
	movl	$0x37363534, -76(%esi)
	movl	$0x3b3a3938, -72(%esi)
	movl	$0x3f3e3d3c, -68(%esi)
	movl	$0x43424140, -64(%esi)
	movl	$0x47464544, -60(%esi)
	movl	$0x4b4a4948, -56(%esi)
	movl	$0x4f4e4d4c, -52(%esi)
	movl	$0x53525150, -48(%esi)
	movl	$0x57565554, -44(%esi)
	movl	$0x5b5a5958, -40(%esi)
	movl	$0x5f5e5d5c, -36(%esi)
	movl	$0x63626160, -32(%esi)
	movl	$0x67666564, -28(%esi)
	movl	$0x6b6a6968, -24(%esi)
	movl	$0x6f6e6d6c, -20(%esi)
	movl	$0x73727170, -16(%esi)
	movl	$0x77767574, -12(%esi)
	movl	$0x7b7a7978, -8(%esi)
	movl	$0x7f7e7d7c, -4(%esi)
	movl	$0x83828180, 0(%esi)
	movl	$0x87868584, 4(%esi)
	movl	$0x8b8a8988, 8(%esi)
	movl	$0x8f8e8d8c, 12(%esi)
	movl	$0x93929190, 16(%esi)
	movl	$0x97969594, 20(%esi)
	movl	$0x9b9a9998, 24(%esi)
	movl	$0x9f9e9d9c, 28(%esi)
	movl	$0xa3a2a1a0, 32(%esi)
	movl	$0xa7a6a5a4, 36(%esi)
	movl	$0xabaaa9a8, 40(%esi)
	movl	$0xafaeadac, 44(%esi)
	movl	$0xb3b2b1b0, 48(%esi)
	movl	$0xb7b6b5b4, 52(%esi)
	movl	$0xbbbab9b8, 56(%esi)
	movl	$0xbfbebdbc, 60(%esi)
	movl	$0xc3c2c1c0, 64(%esi)
	movl	$0xc7c6c5c4, 68(%esi)
	movl	$0xcbcac9c8, 72(%esi)
	movl	$0xcfcecdcc, 76(%esi)
	movl	$0xd3d2d1d0, 80(%esi)
	movl	$0xd7d6d5d4, 84(%esi)
	movl	$0xdbdad9d8, 88(%esi)
	movl	$0xdfdedddc, 92(%esi)
	movl	$0xe3e2e1e0, 96(%esi)
	movl	$0xe7e6e5e4, 100(%esi)
	movzbl	0x200-0x180(%esi), %edi
	movl	$0xebeae9e8, 104(%esi)
	movzbl	0x210-0x180(%esi), %ebp
	movl	$0xefeeedec, 108(%esi)
	movb	-0x180(%esi), %al
	movl	$0xf3f2f1f0, 112(%esi)
	movb	0x100-0x180(%esi), %dl
	movl	$0xf7f6f5f4, 116(%esi)
	movl	$0xfbfaf9f8, 120(%esi)
	movl	$0xfffefdfc, 124(%esi)
	subl	$0x180, %esi

	N16ITER(0);   N16ITER(16);   N16ITER(32);   N16ITER(48)
	N16ITER(64);  N16ITER(80);   N16ITER(96);   N16ITER(112)
	N16ITER(128); N16ITER(144);  N16ITER(160);  N16ITER(176)
	N16ITER(192); N16ITER(208);  N16ITER(224);/*N16ITER(240)*/

	ITER_X2(240); ITER_X2(241); ITER_X2(242); ITER_X2(243);
	ITER_X2(244); ITER_X2(245); ITER_X2(246); ITER_X2(247);
	ITER_X2(248); ITER_X2(249); ITER_X2(250); ITER_X2(251);
	ITER_X2(252); ITER_X2(253); ITER_X2(254);/*ITER_X2(255);*/

	addb	%al, %bl
	addb	%dl, %cl
	movzbl	%bl, %ebx
	movzbl	%cl, %ebx
	addl	%edi, %ebx
	addl	%ebp, %ecx
	andl	$0xFF, %ebx
	andl	$0xFF, %ecx
	movb	(%esi, %ebx), %ah
	movb	0x100(%esi, %ecx), %dh
	movb	%al, (%esi, %ebx)
	movb	%dl, 0x100(%esi, %ecx)
	movb	%ah, 0xFF(%esi)
	movb	%dh, 0x1FF(%esi)

	popl	%edi
	popl	%esi
	popl	%ebp
	popl	%ebx
	popl	%edx
	popl	%ecx

	ret


#define salt	0
#define sign	8
#define check	24
#define name	40
#define pwd	80
#define incr	120
#define mdpwd   376
#define mdchk	440
#define mdres   504
#define rctab1	520
#define rctab2	776
#define rckey1  1032
#define rckey2	1048
#define unchk1	1064
#define unchk2	1096
#define enbuf	1128

/* rc4-128 cryption/uncryption :
	unsigned char everything, rctab[256]; int i, j;
	j=0;	--> j1 in %ebx, j2 in %ecx
	for (i=1;i<=datalen;i++) { --> i in %edi
		j+=rctab[i];	--> rctab1[i] in %al, rctab2[i] in %dl
		j&=0xff;
		t=rctab[i];	--> rctab1[j1] in %ah, rctab2[j2] in %dh
		rctab[i]=rctab[j];
		rctab[j]=t;
		uncrypteddata[i-1]=crypteddata[i-1]^rctab[t+rctab[i]];
	}
	> %esi workspace ptr

   Note : * this function contains only the loop body
	    you must do the initialisation before you call it
	  * first call : 1 -> %edi, 0 -> %ebx, %ecx, pushl datalen
	  * next call  : previous values in %edi, %ebx, %ecx, pushl datalen
*/

	.align 16
	.globl x86_rcxor
x86_rcxor:
	pushl	%edx
	movb	rctab1(%esi,%edi), %al
	movb	rctab2(%esi,%edi), %dl

	.p2align 4
loop:	addb	%al, %bl
	addb	%dl, %cl
/*	movzbl	%bl, %ebx
	movzbl	%cl, %ecx */
	movb	rctab1(%esi,%ebx), %ah
	movb	%al, rctab1(%esi,%ebx)
	movb	rctab2(%esi,%ecx), %dh
	movb	%dl, rctab2(%esi,%ecx)
	movb	%ah, rctab1(%esi,%edi)
	addb	%al, %ah
	movb	%dh, rctab2(%esi,%edi)
	addb	%dl, %dh
	movzbl	%ah, %eax
	movzbl	%dh, %edx
	movb	rctab1(%esi,%eax), %ah
	movb	rctab2(%esi,%edx), %dh
	movb	rctab1+1(%esi,%edi), %al
	movb	rctab2+1(%esi,%edi), %dl
	xorb	sign-1(%esi,%edi), %ah
	incl	%edi
	xorb	sign-2(%esi,%edi), %dh
	movb	%ah, unchk1-2(%esi,%edi)
	cmpl	8(%esp), %edi
	movb	%dh, unchk2-2(%esi,%edi)
	jna	loop

	popl	%edx

	ret
